hpp-constraints: Eigen::MatrixBlockView< _ArgType, _Rows, _Cols, _allRows, _allCols > Class Template Reference

hpp-constraints 9.0.2 Definition of basic geometric constraints for motion planning

Loading...
Searching...
No Matches
Classes | Public Types | Public Member Functions | Public Attributes | List of all members
Eigen::MatrixBlockView< _ArgType, _Rows, _Cols, _allRows, _allCols > Class Template Reference
Constraints » Tools

`#include <hpp/constraints/matrix-view.hh>`

Inheritance diagram for Eigen::MatrixBlockView< _ArgType, _Rows, _Cols, _allRows, _allCols >:
[legend]
Collaboration diagram for Eigen::MatrixBlockView< _ArgType, _Rows, _Cols, _allRows, _allCols >:
[legend]

## Classes
struct | block_iterator
struct | block_t

## Public Types
enum | { Rows = _Rows , Cols = _Cols , AllRows = _allRows , AllCols = _allCols }
typedef hpp::constraints::size_type | size_type
typedef MatrixBase< MatrixBlockView< _ArgType, _Rows, _Cols, _allRows, _allCols > > | Base
typedef Matrix< Scalar, RowsAtCompileTime, ColsAtCompileTime > | PlainObject
typedef _ArgType | ArgType
typedef internal::ref_selector< ArgType >::type | ArgTypeNested
typedef internal::remove_all< ArgType >::type | NestedExpression
typedef block_t< ArgType >::type | BlockXprType
typedef block_t< constArgType >::type | BlockConstXprType
typedef MatrixBlocks< _allRows, _allCols > | MatrixIndices_t
typedef MatrixIndices_t::segments_t | Indices_t
typedef internal::conditional< _allRows, constinternal::empty_struct, constIndices_t & >::type | RowIndices_t
typedef internal::conditional< _allCols, constinternal::empty_struct, constIndices_t & >::type | ColIndices_t

## Public Member Functions
| MatrixBlockView (ArgType &arg, const size_type &nbRows, const RowIndices_t rows, const size_type &nbCols, const ColIndices_t cols)
| MatrixBlockView (ArgType &arg, const size_type &nbIndices, const Indices_t &indices)
| Valid only when _allRows or _allCols is true.
EIGEN_STRONG_INLINE size_type | rows () const
EIGEN_STRONG_INLINE size_type | cols () const
EIGEN_STRONG_INLINE CoeffReturnType | coeff (size_type index) const
EIGEN_STRONG_INLINE CoeffReturnType | coeff (size_type row, size_type col) const
EIGEN_STRONG_INLINE Scalar & | coeffRef (size_type index)
EIGEN_STRONG_INLINE Scalar & | coeffRef (size_type row, const size_type &col)
template<typename Dest >
EIGEN_STRONG_INLINE void | evalTo (Dest &dst) const
template<typename Dest >
EIGEN_STRONG_INLINE void | writeTo (Dest &dst) const
EIGEN_STRONG_INLINE PlainObject | eval () const
template<typename OtherDerived >
EIGEN_STRONG_INLINE MatrixBlockView & | operator= (const EigenBase< OtherDerived > &other)
EIGEN_STRONG_INLINE size_type | _blocks () const
EIGEN_STRONG_INLINE BlockXprType | _block (const block_iterator &b)
EIGEN_STRONG_INLINE const BlockConstXprType | _block (const block_iterator &b) const
EIGEN_STRONG_INLINE block_iterator | _block_iterator () const
EIGEN_STRONG_INLINE bool | isZero (const RealScalar &prec=NumTraits< Scalar >::dummy_precision()) const

## Public Attributes
ArgType & | m_arg
size_type | m_nbRows
RowIndices_t | m_rows
size_type | m_nbCols
ColIndices_t | m_cols

## Detailed Description

template<typename _ArgType, int _Rows = _ArgType::RowsAtCompileTime, int _Cols = _ArgType::ColsAtCompileTime, bool _allRows = false, bool _allCols = false>
class Eigen::MatrixBlockView< _ArgType, _Rows, _Cols, _allRows, _allCols >

A view of an Eigen matrix.

Instances of MatrixBlockView are easily built from a MatrixBlocks object.

As of the date of this documentation, this class does not support all operations on matrices. See tests/matrix-view.cc for a list of supported features.

Although it is usually not useful to iterate over the blocks, it is possible to do it as follows:

MatrixBlockView view = ...;
for (MatrixBlockView::block_iterator block (view); block.valid(); ++block)
{
// Access the current block
view._block(block); // Returns an Eigen::Block object.
// For the current block
block.ri() // row, input
block.ci() // col, input
block.ro() // row, output
block.co() // col, output
block.rs() // number of rows
block.cs() // number of cols
}
Eigen::MatrixBlockView
Definition matrix-view.hh:835
Eigen::MatrixBlockView::_block
EIGEN_STRONG_INLINE BlockXprType _block(const block_iterator &b)
Definition matrix-view.hh:1014
Eigen::MatrixBlockView::block_iterator
Definition matrix-view.hh:839
Eigen::MatrixBlockView::block_iterator::valid
constexpr bool valid() const
Definition matrix-view.hh:904

See also
  MatrixBlocks, MatrixBlockView::block_iterator

## Member Typedef Documentation

## ◆ ArgType

template<typename _ArgType , int _Rows = _ArgType::RowsAtCompileTime, int _Cols = _ArgType::ColsAtCompileTime, bool _allRows = false, bool _allCols = false>

typedef _ArgType Eigen::MatrixBlockView< _ArgType, _Rows, _Cols, _allRows, _allCols >::ArgType

## ◆ ArgTypeNested

template<typename _ArgType , int _Rows = _ArgType::RowsAtCompileTime, int _Cols = _ArgType::ColsAtCompileTime, bool _allRows = false, bool _allCols = false>

typedef internal::ref_selector<ArgType>::type Eigen::MatrixBlockView< _ArgType, _Rows, _Cols, _allRows, _allCols >::ArgTypeNested

## ◆ Base

template<typename _ArgType , int _Rows = _ArgType::RowsAtCompileTime, int _Cols = _ArgType::ColsAtCompileTime, bool _allRows = false, bool _allCols = false>

typedef MatrixBase< MatrixBlockView<_ArgType, _Rows, _Cols, _allRows, _allCols> > Eigen::MatrixBlockView< _ArgType, _Rows, _Cols, _allRows, _allCols >::Base

## ◆ BlockConstXprType

template<typename _ArgType , int _Rows = _ArgType::RowsAtCompileTime, int _Cols = _ArgType::ColsAtCompileTime, bool _allRows = false, bool _allCols = false>

typedef block_t<constArgType>::type Eigen::MatrixBlockView< _ArgType, _Rows, _Cols, _allRows, _allCols >::BlockConstXprType

## ◆ BlockXprType

template<typename _ArgType , int _Rows = _ArgType::RowsAtCompileTime, int _Cols = _ArgType::ColsAtCompileTime, bool _allRows = false, bool _allCols = false>

typedef block_t<ArgType>::type Eigen::MatrixBlockView< _ArgType, _Rows, _Cols, _allRows, _allCols >::BlockXprType

## ◆ ColIndices_t

template<typename _ArgType , int _Rows = _ArgType::RowsAtCompileTime, int _Cols = _ArgType::ColsAtCompileTime, bool _allRows = false, bool _allCols = false>

typedef internal::conditional<_allCols,constinternal::empty_struct,constIndices_t&>::type Eigen::MatrixBlockView< _ArgType, _Rows, _Cols, _allRows, _allCols >::ColIndices_t

## ◆ Indices_t

template<typename _ArgType , int _Rows = _ArgType::RowsAtCompileTime, int _Cols = _ArgType::ColsAtCompileTime, bool _allRows = false, bool _allCols = false>

typedef MatrixIndices_t::segments_t Eigen::MatrixBlockView< _ArgType, _Rows, _Cols, _allRows, _allCols >::Indices_t

## ◆ MatrixIndices_t

template<typename _ArgType , int _Rows = _ArgType::RowsAtCompileTime, int _Cols = _ArgType::ColsAtCompileTime, bool _allRows = false, bool _allCols = false>

typedef MatrixBlocks<_allRows, _allCols> Eigen::MatrixBlockView< _ArgType, _Rows, _Cols, _allRows, _allCols >::MatrixIndices_t

## ◆ NestedExpression

template<typename _ArgType , int _Rows = _ArgType::RowsAtCompileTime, int _Cols = _ArgType::ColsAtCompileTime, bool _allRows = false, bool _allCols = false>

typedef internal::remove_all<ArgType>::type Eigen::MatrixBlockView< _ArgType, _Rows, _Cols, _allRows, _allCols >::NestedExpression

## ◆ PlainObject

template<typename _ArgType , int _Rows = _ArgType::RowsAtCompileTime, int _Cols = _ArgType::ColsAtCompileTime, bool _allRows = false, bool _allCols = false>

typedef Matrix<Scalar, RowsAtCompileTime, ColsAtCompileTime> Eigen::MatrixBlockView< _ArgType, _Rows, _Cols, _allRows, _allCols >::PlainObject

## ◆ RowIndices_t

template<typename _ArgType , int _Rows = _ArgType::RowsAtCompileTime, int _Cols = _ArgType::ColsAtCompileTime, bool _allRows = false, bool _allCols = false>

typedef internal::conditional<_allRows,constinternal::empty_struct,constIndices_t&>::type Eigen::MatrixBlockView< _ArgType, _Rows, _Cols, _allRows, _allCols >::RowIndices_t

## ◆ size_type

template<typename _ArgType , int _Rows = _ArgType::RowsAtCompileTime, int _Cols = _ArgType::ColsAtCompileTime, bool _allRows = false, bool _allCols = false>

typedef hpp::constraints::size_type Eigen::MatrixBlockView< _ArgType, _Rows, _Cols, _allRows, _allCols >::size_type

## Member Enumeration Documentation

## ◆ anonymous enum

template<typename _ArgType , int _Rows = _ArgType::RowsAtCompileTime, int _Cols = _ArgType::ColsAtCompileTime, bool _allRows = false, bool _allCols = false>

anonymous enum

Enumerator
Rows |
Cols |
AllRows |
AllCols |

## Constructor & Destructor Documentation

## ◆ MatrixBlockView() [1/2]

template<typename _ArgType , int _Rows = _ArgType::RowsAtCompileTime, int _Cols = _ArgType::ColsAtCompileTime, bool _allRows = false, bool _allCols = false>

Eigen::MatrixBlockView< _ArgType, _Rows, _Cols, _allRows, _allCols >::MatrixBlockView | ( | ArgType & | arg,
|  | const size_type & | nbRows,
|  | const RowIndices_t | rows,
|  | const size_type & | nbCols,
|  | const ColIndices_t | cols )
| inline

## ◆ MatrixBlockView() [2/2]

template<typename _ArgType , int _Rows = _ArgType::RowsAtCompileTime, int _Cols = _ArgType::ColsAtCompileTime, bool _allRows = false, bool _allCols = false>

Eigen::MatrixBlockView< _ArgType, _Rows, _Cols, _allRows, _allCols >::MatrixBlockView | ( | ArgType & | arg,
|  | const size_type & | nbIndices,
|  | const Indices_t & | indices )
| inline

Valid only when _allRows or _allCols is true.

## Member Function Documentation

## ◆ _block() [1/2]

template<typename _ArgType , int _Rows = _ArgType::RowsAtCompileTime, int _Cols = _ArgType::ColsAtCompileTime, bool _allRows = false, bool _allCols = false>

EIGEN_STRONG_INLINE BlockXprType Eigen::MatrixBlockView< _ArgType, _Rows, _Cols, _allRows, _allCols >::_block | ( | const block_iterator & | b | ) |
| inline

## ◆ _block() [2/2]

template<typename _ArgType , int _Rows = _ArgType::RowsAtCompileTime, int _Cols = _ArgType::ColsAtCompileTime, bool _allRows = false, bool _allCols = false>

EIGEN_STRONG_INLINE const BlockConstXprType Eigen::MatrixBlockView< _ArgType, _Rows, _Cols, _allRows, _allCols >::_block | ( | const block_iterator & | b | ) | const
| inline

## ◆ _block_iterator()

template<typename _ArgType , int _Rows = _ArgType::RowsAtCompileTime, int _Cols = _ArgType::ColsAtCompileTime, bool _allRows = false, bool _allCols = false>

EIGEN_STRONG_INLINE block_iterator Eigen::MatrixBlockView< _ArgType, _Rows, _Cols, _allRows, _allCols >::_block_iterator | ( |  | ) | const
| inline

## ◆ _blocks()

template<typename _ArgType , int _Rows = _ArgType::RowsAtCompileTime, int _Cols = _ArgType::ColsAtCompileTime, bool _allRows = false, bool _allCols = false>

EIGEN_STRONG_INLINE size_type Eigen::MatrixBlockView< _ArgType, _Rows, _Cols, _allRows, _allCols >::_blocks | ( |  | ) | const
| inline

## ◆ coeff() [1/2]

template<typename _ArgType , int _Rows = _ArgType::RowsAtCompileTime, int _Cols = _ArgType::ColsAtCompileTime, bool _allRows = false, bool _allCols = false>

EIGEN_STRONG_INLINE CoeffReturnType Eigen::MatrixBlockView< _ArgType, _Rows, _Cols, _allRows, _allCols >::coeff | ( | size_type | index | ) | const
| inline

## ◆ coeff() [2/2]

template<typename _ArgType , int _Rows = _ArgType::RowsAtCompileTime, int _Cols = _ArgType::ColsAtCompileTime, bool _allRows = false, bool _allCols = false>

EIGEN_STRONG_INLINE CoeffReturnType Eigen::MatrixBlockView< _ArgType, _Rows, _Cols, _allRows, _allCols >::coeff | ( | size_type | row,
|  | size_type | col ) const
| inline

## ◆ coeffRef() [1/2]

template<typename _ArgType , int _Rows = _ArgType::RowsAtCompileTime, int _Cols = _ArgType::ColsAtCompileTime, bool _allRows = false, bool _allCols = false>

EIGEN_STRONG_INLINE Scalar & Eigen::MatrixBlockView< _ArgType, _Rows, _Cols, _allRows, _allCols >::coeffRef | ( | size_type | index | ) |
| inline

## ◆ coeffRef() [2/2]

template<typename _ArgType , int _Rows = _ArgType::RowsAtCompileTime, int _Cols = _ArgType::ColsAtCompileTime, bool _allRows = false, bool _allCols = false>

EIGEN_STRONG_INLINE Scalar & Eigen::MatrixBlockView< _ArgType, _Rows, _Cols, _allRows, _allCols >::coeffRef | ( | size_type | row,
|  | const size_type & | col )
| inline

## ◆ cols()

template<typename _ArgType , int _Rows = _ArgType::RowsAtCompileTime, int _Cols = _ArgType::ColsAtCompileTime, bool _allRows = false, bool _allCols = false>

EIGEN_STRONG_INLINE size_type Eigen::MatrixBlockView< _ArgType, _Rows, _Cols, _allRows, _allCols >::cols | ( |  | ) | const
| inline

## ◆ eval()

template<typename _ArgType , int _Rows = _ArgType::RowsAtCompileTime, int _Cols = _ArgType::ColsAtCompileTime, bool _allRows = false, bool _allCols = false>

EIGEN_STRONG_INLINE PlainObject Eigen::MatrixBlockView< _ArgType, _Rows, _Cols, _allRows, _allCols >::eval | ( |  | ) | const
| inline

## ◆ evalTo()

template<typename _ArgType , int _Rows = _ArgType::RowsAtCompileTime, int _Cols = _ArgType::ColsAtCompileTime, bool _allRows = false, bool _allCols = false>
template<typename Dest >

EIGEN_STRONG_INLINE void Eigen::MatrixBlockView< _ArgType, _Rows, _Cols, _allRows, _allCols >::evalTo | ( | Dest & | dst | ) | const
| inline

## ◆ isZero()

template<typename _ArgType , int _Rows = _ArgType::RowsAtCompileTime, int _Cols = _ArgType::ColsAtCompileTime, bool _allRows = false, bool _allCols = false>

EIGEN_STRONG_INLINE bool Eigen::MatrixBlockView< _ArgType, _Rows, _Cols, _allRows, _allCols >::isZero | ( | const RealScalar & | prec = NumTraits<Scalar>::dummy_precision() | ) | const
| inline

## ◆ operator=()

template<typename _ArgType , int _Rows = _ArgType::RowsAtCompileTime, int _Cols = _ArgType::ColsAtCompileTime, bool _allRows = false, bool _allCols = false>
template<typename OtherDerived >

EIGEN_STRONG_INLINE MatrixBlockView & Eigen::MatrixBlockView< _ArgType, _Rows, _Cols, _allRows, _allCols >::operator= | ( | const EigenBase< OtherDerived > & | other | ) |
| inline

## ◆ rows()

template<typename _ArgType , int _Rows = _ArgType::RowsAtCompileTime, int _Cols = _ArgType::ColsAtCompileTime, bool _allRows = false, bool _allCols = false>

EIGEN_STRONG_INLINE size_type Eigen::MatrixBlockView< _ArgType, _Rows, _Cols, _allRows, _allCols >::rows | ( |  | ) | const
| inline

## ◆ writeTo()

template<typename _ArgType , int _Rows = _ArgType::RowsAtCompileTime, int _Cols = _ArgType::ColsAtCompileTime, bool _allRows = false, bool _allCols = false>
template<typename Dest >

EIGEN_STRONG_INLINE void Eigen::MatrixBlockView< _ArgType, _Rows, _Cols, _allRows, _allCols >::writeTo | ( | Dest & | dst | ) | const
| inline

## Member Data Documentation

## ◆ m_arg

template<typename _ArgType , int _Rows = _ArgType::RowsAtCompileTime, int _Cols = _ArgType::ColsAtCompileTime, bool _allRows = false, bool _allCols = false>

ArgType& Eigen::MatrixBlockView< _ArgType, _Rows, _Cols, _allRows, _allCols >::m_arg

## ◆ m_cols

template<typename _ArgType , int _Rows = _ArgType::RowsAtCompileTime, int _Cols = _ArgType::ColsAtCompileTime, bool _allRows = false, bool _allCols = false>

ColIndices_t Eigen::MatrixBlockView< _ArgType, _Rows, _Cols, _allRows, _allCols >::m_cols

## ◆ m_nbCols

template<typename _ArgType , int _Rows = _ArgType::RowsAtCompileTime, int _Cols = _ArgType::ColsAtCompileTime, bool _allRows = false, bool _allCols = false>

size_type Eigen::MatrixBlockView< _ArgType, _Rows, _Cols, _allRows, _allCols >::m_nbCols

## ◆ m_nbRows

template<typename _ArgType , int _Rows = _ArgType::RowsAtCompileTime, int _Cols = _ArgType::ColsAtCompileTime, bool _allRows = false, bool _allCols = false>

size_type Eigen::MatrixBlockView< _ArgType, _Rows, _Cols, _allRows, _allCols >::m_nbRows

## ◆ m_rows

template<typename _ArgType , int _Rows = _ArgType::RowsAtCompileTime, int _Cols = _ArgType::ColsAtCompileTime, bool _allRows = false, bool _allCols = false>

RowIndices_t Eigen::MatrixBlockView< _ArgType, _Rows, _Cols, _allRows, _allCols >::m_rows

The documentation for this class was generated from the following file:

- include/hpp/constraints/matrix-view.hh